--- old/usr/src/man/man3c_db/td_thr_getgregs.3c_db	Wed Apr 12 20:33:25 2023
+++ new/usr/src/man/man3c_db/td_thr_getgregs.3c_db	Wed Apr 12 20:33:25 2023
@@ -1,184 +1,127 @@
-'\" te
+.\"
 .\"  Copyright (c) 1998 Sun Microsystems, Inc.  All Rights Reserved
 .\" The contents of this file are subject to the terms of the Common Development and Distribution License (the "License").  You may not use this file except in compliance with the License.
 .\" You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE or http://www.opensolaris.org/os/licensing.  See the License for the specific language governing permissions and limitations under the License.
 .\" When distributing Covered Code, include this CDDL HEADER in each file and include the License file at usr/src/OPENSOLARIS.LICENSE.  If applicable, add the following below this CDDL HEADER, with the fields enclosed by brackets "[]" replaced with your own identifying information: Portions Copyright [yyyy] [name of copyright owner]
-.TH TD_THR_GETGREGS 3C_DB "Oct 20, 1998"
-.SH NAME
-td_thr_getgregs, td_thr_setgregs, td_thr_getfpregs, td_thr_setfpregs,
-td_thr_getxregsize, td_thr_getxregs, td_thr_setxregs \- reading and writing
-thread registers in libc_db
-.SH SYNOPSIS
-.LP
-.nf
-cc [ \fIflag\fR... ] \fIfile\fR... -lc_db [ \fIlibrary\fR... ]
-#include <proc_service.h>
-#include <thread_db.h>
-
-\fBtd_err_e\fR \fBtd_thr_getgregs\fR(\fBconst td_thrhandle_t *\fR\fIth_p\fR, \fBprgregset_t\fR\fIgregset\fR);
-.fi
-
-.LP
-.nf
-\fBtd_err_e\fR \fBtd_thr_setgregs\fR(\fBconst td_thrhandle_t *\fR\fIth_p\fR, \fBprgregset_t\fR\fIgregset\fR);
-.fi
-
-.LP
-.nf
-\fBtd_err_e\fR \fBtd_thr_getfpregs\fR(\fBconst td_thrhandle_t *\fR\fIth_p\fR, \fBprfpregset_t *\fR\fIfpregset\fR);
-.fi
-
-.LP
-.nf
-\fBtd_err_e\fR \fBtd_thr_setfpregs\fR(\fBconst td_thrhandle_t *\fR\fIth_p\fR, \fBprfpregset_t *\fR\fIfpregset\fR);
-.fi
-
-.LP
-.nf
-\fBtd_err_e\fR \fBtd_thr_getxregsize\fR(\fBconst td_thrhandle_t *\fR\fIth_p\fR, \fBint *\fR\fIxregsize\fR);
-.fi
-
-.LP
-.nf
-\fBtd_err_e\fR \fBtd_thr_getxregs\fR(\fBconst td_thrhandle_t *\fR\fIth_p\fR, \fBprxregset_t *\fR\fIxregset\fR);
-.fi
-
-.LP
-.nf
-\fBtd_err_e\fR \fBtd_thr_setxregs\fR(\fBconst td_thrhandle_t *\fR\fIth_p\fR, \fBprxregset_t *\fR\fIxregset\fR);
-.fi
-
-.SH DESCRIPTION
-.sp
-.LP
+.\" Copyright 2023 Oxide Computer Company
+.Dd January 23, 2023
+.Dt TD_THR_GETGREGS 3C_DB
+.Os
+.Sh NAME
+.Nm td_thr_getgregs ,
+.Nm td_thr_setgregs ,
+.Nm td_thr_getfpregs ,
+.Nm td_thr_setfpregs ,
+.Nm td_thr_getxregsize ,
+.Nm td_thr_getxregs ,
+.Nm td_thr_setxregs
+.Nd reading and writing thread registers in libc_db
+.Sh LIBRARY
+.Lb libc_db
+.Sh SYNOPSIS
+.In proc_service.h
+.In thread_db.h
+.Ft td_err_e
+.Fo td_thr_getgregs
+.Fa "const td_thrhandle_t *th_p"
+.Fa "prgregset_t gregset"
+.Fc
+.Ft td_err_e
+.Fo td_thr_setgregs
+.Fa "const td_thrhandle_t *th_p"
+.Fa "prgregset_t gregset"
+.Fc
+.Ft td_err_e
+.Fo td_thr_getfpregs
+.Fa "const td_thrhandle_t *th_p"
+.Fa "prfpregset_t *fpregset"
+.Fc
+.Ft td_err_e
+.Fo td_thr_setfpregs
+.Fa "const td_thrhandle_t *th_p"
+.Fa "prfpregset_t *fpregset"
+.Fc
+.Ft td_err_e
+.Fo td_thr_getxregsize
+.Fa "const td_thrhandle_t *th_p"
+.Fa "int *xregsize"
+.Fc
+.Ft td_err_e
+.Fo td_thr_getxregs
+.Fa "const td_thrhandle_t *th_p"
+.Fa "prxregset_t *xregset"
+.Fc
+.Ft td_err_e
+.Fo td_thr_setxregs
+.Fa "const td_thrhandle_t *th_p"
+.Fa "prxregset_t *xregset"
+.Fc
+.Sh DESCRIPTION
 These functions read and write the register sets associated with thread
-\fIth_p\fR. The \fBtd_thr_getgregs()\fR and \fBtd_thr_setgregs()\fR functions
-get and set, respectively, the general registers of thread \fIth_p\fR. The
-\fBtd_thr_getfpregs()\fR and \fBtd_thr_setfpregs()\fR functions get and set,
-respectively, the thread's floating point register set. The
-\fBtd_thr_getxregsize()\fR, \fBtd_thr_getxregs()\fR, and
-\fBtd_thr_setxregs()\fR functions are SPARC-specific. The
-\fBtd_thr_getxregsize()\fR function returns in *\fIxregsize\fR the size of the
-architecture-dependent extra state registers. The \fBtd_thr_getxregs()\fR and
-\fBtd_thr_setxregs()\fR functions get and set, respectively, those extra state
-registers. On non-SPARC architectures, these functions return \fBTD_NOXREGS\fR.
-.sp
-.LP
-If the thread specified by \fIth_p\fR is currently executing on a lightweight
-process ( \fBLWP),\fR these functions read or write, respectively, the
-appropriate register set to the \fBLWP\fR using the imported interface. If the
-thread is not  currently executing on an \fBLWP\fR, the floating point and
-extra state registers may cannot be read or written. Some of the general
-registers might also not be readable or writable, depending on the
-architecture, in which case \fBtd_thr_getfpregs()\fR and
-\fBtd_thr_setfpregs()\fR return  \fBTD_NOFPREGS\fR and \fBtd_thr_getxregs()\fR
-and \fBtd_thr_setxregs()\fR will \fBTD_NOXREGS\fR. Calls to
-\fBtd_thr_getgregs()\fR and \fBtd_thr_setgregs()\fR succeed, but values
-returned for unreadable registers are undefined, values specified for
-unwritable registers are ignored. In this instance, and \fBTD_PARTIALREGS\fR is
-returned.  See the architecture-specific notes that follow regarding the
-registers that may be read and written for a thread not currently executing on
-an \fBLWP\fR.
-.SS "SPARC"
-.sp
-.LP
-On a thread not currently assigned to an \fBLWP\fR, only %i0-%i7, %l0-%l7, %g7,
-%pc, and %sp (%o6) can be read or written.  %pc and %sp refer to the program
-counter and stack pointer that the thread will have when it resumes execution.
-.SS "x86 Architecture"
-.sp
-.LP
-On a thread not currently assigned to an \fBLWP,\fR only %pc, %sp, %ebp, %edi,
-%edi, and %ebx can be read.
-.SH RETURN VALUES
-.sp
-.ne 2
-.na
-\fB\fBTD_OK\fR\fR
-.ad
-.RS 18n
+.Fa th_p .
+The
+.Fn td_thr_getgregs
+and
+.Fn td_thr_setgregs
+functions get and set, respectively, the general registers of thread
+.Fa th_p .
+The
+.Fn td_thr_getfpregs
+and
+.Fn td_thr_setfpregs
+functions get and set, respectively, the thread's floating point register set.
+.Pp
+The
+.Fn td_thr_getxregsize
+function returns in
+.Fa *xregsize
+the size of the
+architecture-dependent extra state registers.
+The
+.Fn td_thr_getxregs
+and
+.Fn td_thr_setxregs
+functions get and set, respectively, those extra state registers.
+The buffer passed to
+.Fn td_thr_getxregs
+must be at least the size indicated by
+.Fn td_thr_getxregsize .
+This size must not be assumed and may change between processes.
+Failure to do so, will result in the system overwriting memory.
+Not all platforms implement extended registers.
+When they are not implemented, these functions return
+.Dv TD_NOXREGS .
+.Sh RETURN VALUES
+The
+.Fn td_thr_getgregs ,
+.Fn td_thr_setgregs ,
+.Fn td_thr_getfpregs ,
+.Fn td_thr_setfpregs ,
+.Fn td_thr_getxregsize ,
+.Fn td_thr_getxregs ,
+and
+.Fn td_thr_setxregs
+functions return one of the following values:
+.Bl -tag -width Ds
+.It Dv TD_OK
 The call completed successfully.
-.RE
-
-.sp
-.ne 2
-.na
-\fB\fBTD_BADTH\fR\fR
-.ad
-.RS 18n
+.It Dv TD_BADTH
 An invalid thread handle was passed in.
-.RE
-
-.sp
-.ne 2
-.na
-\fB\fBTD_DBERR\fR\fR
-.ad
-.RS 18n
+.It Dv TD_DBERR
 A call to one of the imported interface routines failed.
-.RE
-
-.sp
-.ne 2
-.na
-\fB\fBTD_PARTIALREGS\fR\fR
-.ad
-.RS 18n
-Because the thread is not currently assigned to a \fBLWP,\fR not all registers
-were read or written. See \fBDESCRIPTION\fR for a discussion about which
-registers are not saved when a thread is not assigned to an \fBLWP\fR.
-.RE
-
-.sp
-.ne 2
-.na
-\fB\fBTD_NOFPREGS\fR\fR
-.ad
-.RS 18n
-Floating point registers could not be read or written, either because the
-thread is not currently assigned to an \fBLWP\fR, or because the architecture
+.It Dv TD_NOFPREGS
+Floating point registers could not be read or written because the architecture
 does not have such registers.
-.RE
-
-.sp
-.ne 2
-.na
-\fB\fBTD_NOXREGS\fR\fR
-.ad
-.RS 18n
+.It Dv TD_NOXREGS
 Architecture-dependent extra state registers could not be read or written,
-either because the thread is not currently assigned to an \fBLWP\fR, or because
-the architecture does not have such registers, or because the architecture is
-not a SPARC architecture.
-.RE
-
-.sp
-.ne 2
-.na
-\fB\fBTD_ERR\fR\fR
-.ad
-.RS 18n
-A \fBlibc_db\fR internal error occurred.
-.RE
-
-.SH ATTRIBUTES
-.sp
-.LP
-See \fBattributes\fR(7) for description of the following attributes:
-.sp
-
-.sp
-.TS
-box;
-c | c
-l | l .
-ATTRIBUTE TYPE	ATTRIBUTE VALUE
-_
-MT-Level	Safe
-.TE
-
-.SH SEE ALSO
-.sp
-.LP
-.BR libc_db (3LIB),
-.BR attributes (7)
+because the architecture does not have such registers.
+.It Dv TD_ERR
+A
+.Sy libc_db
+internal error occurred.
+.El
+.Sh MT-LEVEL
+.Sy Safe
+.Sh SEE ALSO
+.Xr libc_db 3LIB ,
+.Xr attributes 7
--- old/usr/src/man/man3lib/libproc.3lib	Wed Apr 12 20:33:25 2023
+++ new/usr/src/man/man3lib/libproc.3lib	Wed Apr 12 20:33:25 2023
@@ -12,8 +12,9 @@
 .\" Copyright 2018 Joyent, Inc.
 .\" Copyright (c) 2019 Carlos Neira <cneirabustos@gmail.com>
 .\" Copyright 2020 OmniOS Community Edition (OmniOSce) Association.
+.\" Copyright 2023 Oxide Computer Company
 .\"
-.Dd March 10, 2023
+.Dd March 20, 2023
 .Dt LIBPROC 3LIB
 .Os
 .Sh NAME
@@ -218,11 +219,6 @@
 .It Sy Pissyscall_prev Ta Sy Plmid
 .It Sy Plmid_to_loadobj Ta Sy Plmid_to_map
 .It Sy Plookup_by_addr Ta Sy Plookup_by_name
-.It Sy Plwp_alt_stack Ta Sy Plwp_getfpregs
-.It Sy Plwp_getname Ta Sy Plwp_getpsinfo
-.It Sy Plwp_getregs Ta Sy Plwp_getspymaster
-.It Sy Plwp_main_stack Ta Sy Plwp_setfpregs
-.It Sy Plwp_setregs Ta Sy Plwp_stack
 .It Sy Pname_to_ctf Ta Sy Pname_to_loadobj
 .It Sy Pname_to_map Ta Sy Pobjname
 .It Sy Pobjname_resolved Ta Sy Pplatform
@@ -256,14 +252,26 @@
 .It Sy Lalt_stack Ta Sy Lclearfault
 .It Sy Lclearsig Ta Sy Lctlfd
 .It Sy Ldstop Ta Sy Lgetareg
-.It Sy Lmain_stack Ta Sy Lprochandle
-.It Sy Lpsinfo Ta Sy Lputareg
-.It Sy Lsetrun Ta Sy Lstack
+.It Sy Lgetfpregs Ta Sy Lgetregs
+.It Sy Lgetxregs Ta Sy Lmain_stack
+.It Sy Lprochandle Ta Sy Lpsinfo
+.It Sy Lputareg Ta Sy Lsetrun
+.It Sy Lsetfpregs Ta Sy Lsetregs
+.It Sy Lsetxregs Ta Sy Lstack
 .It Sy Lstate Ta Sy Lstatus
 .It Sy Lstop Ta Sy Lsync
 .It Sy Lwait Ta Sy Lxecbkpt
-.It Sy Lxecwapt Ta ""
+.It Sy Lxecwapt Ta Sy ""
 .El
+.Bl -column -offset indent ".Sy Pmapping_iter_resolved" ".Sy Psymbol_iter_by_addr"
+.It Sy Plwp_alt_stack Ta Sy Plwp_freexregs
+.It Sy Plwp_getfpregs Ta Sy Plwp_getname
+.It Sy Plwp_getpsinfo Ta Sy Plwp_getregs
+.It Sy Plwp_getspymaster Ta Sy Plwp_main_stack
+.It Sy Plwp_getxregs Ta Sy Plwp_setfpregs
+.It Sy Plwp_setregs Ta Sy Plwp_setxregs
+.It Sy Plwp_stack Ta Sy ""
+.El
 .Ss System Call Injection
 The following routines are used to inject specific system calls and have
 them run in the context of a process.
@@ -338,8 +346,7 @@
 .Nm
 library.
 .Bl -column -offset indent ".Sy Pmapping_iter_resolved" ".Sy Psymbol_iter_by_addr"
-.It Sy Plwp_getgwindows Ta Sy Plwp_getxregs
-.It Sy Plwp_setxregs Ta Sy ""
+.It Sy Plwp_getgwindows Ta Sy ""
 .El
 .Pp
 The following functions are specific to the 64-bit SPARC version of the
--- old/usr/src/man/man3proc/Makefile	Wed Apr 12 20:33:25 2023
+++ new/usr/src/man/man3proc/Makefile	Wed Apr 12 20:33:25 2023
@@ -180,9 +180,15 @@
 		Lclearsig.3proc			\
 		Ldstop.3proc			\
 		Lgetareg.3proc			\
+		Lgetfpregs.3proc		\
+		Lgetregs.3proc			\
+		Lgetxregs.3proc			\
 		Lmain_stack.3proc		\
 		Lputareg.3proc			\
+		Lsetfpregs.3proc		\
+		Lsetregs.3proc			\
 		Lsetrun.3proc			\
+		Lsetxregs.3proc			\
 		Lstack.3proc			\
 		Lstop.3proc			\
 		Lsync.3proc			\
@@ -201,6 +207,7 @@
 		Plmid_to_map.3proc		\
 		Plookup_by_name.3proc		\
 		Plwp_alt_stack.3proc		\
+		Plwp_freexregs.3proc		\
 		Plwp_getfpregs.3proc		\
 		Plwp_iter_all.3proc		\
 		Plwp_main_stack.3proc		\
@@ -355,6 +362,10 @@
 Plwp_setregs.3proc		:= LINKSRC = Plwp_getregs.3proc
 Plwp_getfpregs.3proc		:= LINKSRC = Plwp_getregs.3proc
 Plwp_setfpregs.3proc		:= LINKSRC = Plwp_getregs.3proc
+Lgetfpregs.3proc		:= LINKSRC = Plwp_getregs.3proc
+Lsetfpregs.3proc		:= LINKSRC = Plwp_getregs.3proc
+Lgetregs.3proc			:= LINKSRC = Plwp_getregs.3proc
+Lsetregs.3proc			:= LINKSRC = Plwp_getregs.3proc
 
 Plwp_alt_stack.3proc		:= LINKSRC = Plwp_stack.3proc
 Plwp_main_stack.3proc		:= LINKSRC = Plwp_stack.3proc
@@ -431,7 +442,10 @@
 
 proc_get_ldt.3proc		:= LINKSRC = Pldt.3proc
 
+Plwp_freexregs.3proc		:= LINKSRC = Plwp_getxregs.3proc
 Plwp_setxregs.3proc		:= LINKSRC = Plwp_getxregs.3proc
+Lgetxregs.3proc			:= LINKSRC = Plwp_getxregs.3proc
+Lsetxregs.3proc			:= LINKSRC = Plwp_getxregs.3proc
 
 Plwp_setasrs.3proc		:= LINKSRC = Plwp_getasrs.3proc
 
--- old/usr/src/man/man3proc/Plwp_getregs.3proc	Wed Apr 12 20:33:25 2023
+++ new/usr/src/man/man3proc/Plwp_getregs.3proc	Wed Apr 12 20:33:25 2023
@@ -10,8 +10,9 @@
 .\"
 .\"
 .\" Copyright 2015 Joyent, Inc.
+.\" Copyright 2023 Oxide Computer Company
 .\"
-.Dd May 02, 2020
+.Dd January 19, 2023
 .Dt PLWP_GETREGS 3PROC
 .Os
 .Sh NAME
@@ -18,7 +19,11 @@
 .Nm Plwp_getfpregs ,
 .Nm Plwp_setfpregs ,
 .Nm Plwp_getregs ,
-.Nm Plwp_setregs
+.Nm Plwp_setregs ,
+.Nm Lgetfpregs ,
+.Nm Lsetfpregs ,
+.Nm Lgetregs ,
+.Nm Lsetregs
 .Nd get and set thread registers
 .Sh LIBRARY
 .Lb libproc
@@ -48,6 +53,26 @@
 .Fa "lwpid_t lwpid"
 .Fa "const prgregset_t gregs"
 .Fc
+.Ft int
+.Fo Lgetfpregs
+.Fa "struct ps_lwphandle *L"
+.Fa "prfpregset_t *fpregs"
+.Fc
+.Ft int
+.Fo Lsetfpregs
+.Fa "struct ps_lwphandle *L"
+.Fa "const prfpregset_t *fpregs"
+.Fc
+.Ft int
+.Fo Lgetregs
+.Fa "struct ps_lwphandle *L"
+.Fa "prgregset_t gregs"
+.Fc
+.Ft int
+.Fo Lsetregs
+.Fa "struct ps_lwphandle *L"
+.Fa "const prgregset_t gregs"
+.Fc
 .Sh DESCRIPTION
 The
 .Fn Plwp_getregs ,
@@ -105,13 +130,47 @@
 .Pp
 One may not set the register values of a process that is not an active
 process, e.g. a process handle that refers to a file or a core file.
+.Pp
+The
+.Fn Lgetfpregs ,
+.Fn Lsetfpregs ,
+.Fn Lgetregs ,
+and
+.Fn Lsetregs
+functions behave in a same way as the corresponding process-handle
+specific functions, with the following differences:
+.Bl -dash
+.It
+Rather than take a specified thread id via
+.Fa lwpid ,
+they operate on the thread that the thread-handle,
+.Fa L ,
+refers to.
+.It
+The process-handle functions will require that the entire process is
+stopped before performing a set operation.
+In these cases, only the specific thread identified by the handle
+.Fa L
+must be stopped through a call to
+.Xr Lstop 3PROC
+or similar.
+Note, a suspended thread
+.Po
+.Xr thr_suspend 3C
+.Pc
+is not considered stopped for these purposes.
+.El
 .Sh RETURN VALUES
 Upon successful completion, the
 .Fn Plwp_getregs ,
 .Fn Plwp_setregs ,
 .Fn Plwp_getfpregs ,
+.Fn Plwp_setfpregs ,
+.Fn Lgetfpregs ,
+.Fn Lsetfpregs ,
+.Fn Lgetregs ,
 and
-.Fn Plwp_setfpregs
+.Fn Lsetregs
 functions return
 .Sy 0
 and obtain or set the register state.
@@ -118,10 +177,12 @@
 Otherwise,
 .Sy -1
 is returned,
-.Sy errno
+.Va errno
 is set to indicate the error, and the register state is not updated nor
 are the data pointers changed.
 .Sh ERRORS
+The implementations of these functions may use standard system and
+library calls that can fail.
 For a full list of possible errors also see the
 .Sy DIAGNOSTICS
 section in
@@ -145,6 +206,19 @@
 with id
 .Fa lwpid .
 .El
+The
+.Fn Lgetfpregs ,
+.Fn Lsetfpregs ,
+.Fn Lgetregs ,
+and
+.Fn Lsetregs
+will fail if:
+.Bl -tag -width Er
+.It Er EBUSY
+The thread handle
+.Fa L
+is not currently stopped.
+.El
 .Sh INTERFACE STABILITY
 .Sy Uncommitted
 .Sh MT-LEVEL
--- old/usr/src/man/man3proc/Plwp_getxregs.3proc	Wed Apr 12 20:33:25 2023
+++ new/usr/src/man/man3proc/Plwp_getxregs.3proc	Wed Apr 12 20:33:25 2023
@@ -10,13 +10,17 @@
 .\"
 .\"
 .\" Copyright 2015 Joyent, Inc.
+.\" Copyright 2023 Oxide Computer Company
 .\"
-.Dd May 11, 2016
+.Dd January 19, 2023
 .Dt PLWP_GETXREGS 3PROC
 .Os
 .Sh NAME
 .Nm Plwp_getxregs ,
-.Nm Plwp_setxregs
+.Nm Plwp_freexregs ,
+.Nm Plwp_setxregs ,
+.Nm Lgetxregs ,
+.Nm Lsetxregs
 .Nd get and set extended register state
 .Sh LIBRARY
 .Lb libproc
@@ -26,7 +30,15 @@
 .Fo Plwp_getxregs
 .Fa "struct ps_prochandle *P"
 .Fa "lwpid_t lwpid"
+.Fa "prxregset_t **xregsp"
+.Fa "size_t *sizep"
+.Fc
+.Ft int
+.Fo Plwp_freexregs
+.Fa "struct ps_prochandle *P"
+.Fa "lwpid_t lwpid"
 .Fa "prxregset_t *xregs"
+.Fa "size_t size"
 .Fc
 .Ft int
 .Fo Plwp_setxregs
@@ -34,6 +46,17 @@
 .Fa "lwpid_t lwpid"
 .Fa "const prxregset_t *xregs"
 .Fc
+.Ft int
+.Fo Lgetxregs
+.Fa "struct ps_lwphandle *L"
+.Fa "prxregset_t **xregsp"
+.Fa "size_t *sizep"
+.Fc
+.Ft int
+.Fo Lsetxregs
+.Fa "struct ps_lwphandle *L"
+.Fa "const prxregset_t *xregs"
+.Fc
 .Sh DESCRIPTION
 The
 .Fn Plwp_getxregs
@@ -46,17 +69,45 @@
 .Pp
 The extended register state is defined by the architecture.
 These registers may refer to optional registers that have become common on the
-platform, but are not part of the standard ABI and thus not covered by
+platform, but are not part of the traditional ABI and thus not covered by
 functions such as
 .Xr Plwp_getregs 3PROC
 and
 .Xr Plwp_getfpregs 3PROC .
+Support for the extended registers varies based on the architecture and
+varies based on the specific system.
+For example, on x86 based CPUs the xregs functionality requires the x86
+xsave functionality to be supported.
 .Pp
 The
 .Fn Plwp_getxregs
-function gets the extended register state information and places it into
-.Fa xregs .
-Where as the
+function gets the extended register state information, allocates the
+appropriate sized buffer for it, and places a pointer to that buffer
+into
+.Fa xregs
+and updates
+.Fa sizep
+to indicate the size of the allocated structure.
+Due to the fact that hardware has varying sized extended register sets,
+the exact size of the structure can vary between different running
+systems and core files.
+It is also possible that some processor extensions are enabled at
+process runtime, leading for this to further be different between
+different processes on the same system.
+As such, all of the different platform instantiations of the
+.Vt prxregset_t
+end up generally being opaque structures that can be cast to something
+more specific that also includes its size.
+.Pp
+The obtained
+.Vt prxregset_t
+in
+.Fa xregsp
+must be freed by the caller with the
+.Fn Plwp_freexregs
+function.
+.Pp
+The
 .Fn Plwp_setxregs
 function sets the extended register state information in
 .Fa xregs
@@ -75,6 +126,24 @@
 .Pp
 One may not set the register values of a process that is not an active
 process, e.g. a process handle that refers to a file or a core file.
+.Pp
+The
+.Fn Lgetxregs
+and
+.Fn Lsetxregs
+functions are equivalent to the
+.Fn Plwp_getxregs
+and
+.Fn Plwp_setxregs
+functions except that they operate on a specific thread identified by
+the handle
+.Fa L
+and only require that the thread in question be stopped.
+Data allocated with the
+.Fn Lgetxregs
+functions should be freed with the
+.Fn Plwp_freexregs
+function.
 .Sh RETURN VALUES
 Upon successful completion, the
 .Fn Plwp_getxregs
@@ -104,29 +173,33 @@
 The process handle
 .Fa P
 does not have any extended register state information.
+This generally happens because the platform does not support it.
 .It Er EBUSY
 The process handle
 .Fa P
 refers to a live process and it is not stopped.
 .It Er ENOENT
-The process handle
-.Fa P
-refers to a live process and there is no thread with id
-.Fa lwpid .
-.It Er EINVAL
-The process handle
-.Fa P
-refers to a core file and there is no thread with id
-.Fa lwpid .
+There is no thread with id
+.Fa lwpid
+in the process handle
+.Fa P .
 .El
-.Sh ARCHITECTURE
 The
-.Fn Plwp_getxregs
+.Fn Lgetxregs
 and
-.Fn Plwp_setxregs
-functions are only available on
-.Sy SPARC
-platforms.
+.Fn Lsetxregs
+function will fail if:
+.Bl -tag -width Er
+.It Er ENODATA
+The thread handle
+.Fa L
+does not have any extended register state information.
+This generally happens because the platform does not support it.
+.It Er EBUSY
+The thread handle
+.Fa L
+refers to a live process and the thread is not stopped.
+.El
 .Sh INTERFACE STABILITY
 .Sy Uncommitted
 .Sh MT-LEVEL
--- old/usr/src/man/man3proc/proc_service.3proc	Wed Apr 12 20:33:26 2023
+++ new/usr/src/man/man3proc/proc_service.3proc	Wed Apr 12 20:33:26 2023
@@ -3,11 +3,10 @@
 .\" The contents of this file are subject to the terms of the Common Development and Distribution License (the "License").  You may not use this file except in compliance with the License.
 .\" You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE or http://www.opensolaris.org/os/licensing.  See the License for the specific language governing permissions and limitations under the License.
 .\" When distributing Covered Code, include this CDDL HEADER in each file and include the License file at usr/src/OPENSOLARIS.LICENSE.  If applicable, add the following below this CDDL HEADER, with the fields enclosed by brackets "[]" replaced with your own identifying information: Portions Copyright [yyyy] [name of copyright owner]
-.TH PROC_SERVICE 3PROC "Oct 12, 2007"
+.TH PROC_SERVICE 3PROC "Jan 23, 2023"
 .SH NAME
 proc_service \- process service interfaces
 .SH SYNOPSIS
-.LP
 .nf
 #include <proc_service.h>
 
@@ -131,7 +130,6 @@
 \fBvoid\fR \fBps_plog\fR(\fBconst char *\fR\fIfmt\fR);
 .fi
 
-.SS "SPARC"
 .LP
 .nf
 \fBps_err_e\fR \fBps_lgetxregsize\fR(\fBstruct ps_prochandle *\fR\fIph\fR,
@@ -151,7 +149,6 @@
 .fi
 
 .SS "x86"
-.LP
 .nf
 \fBps_err_e\fR \fBps_lgetLDT\fR(\fBstruct ps_prochandle *\fR\fIph\fR, \fBlwpid_t\fR \fIlwpid\fR,
      \fBstruct ssd *\fR\fIldt\fR);
@@ -158,7 +155,6 @@
 .fi
 
 .SH DESCRIPTION
-.LP
 Every program that links \fBlibthread_db\fR or \fBlibrtld_db\fR must provide a
 set of process control primitives that allow \fBlibthread_db\fR and
 \fBlibrtld_db\fR to access memory and registers in the target process, to start
@@ -363,7 +359,6 @@
 Logs a message.
 .RE
 
-.SS "SPARC"
 .ne 2
 .na
 \fB\fBps_lgetxregsize()\fR\fR
@@ -400,7 +395,6 @@
 .RE
 
 .SH ATTRIBUTES
-.LP
 See \fBattributes\fR(7) for description of the following attributes:
 .sp
 
@@ -415,7 +409,6 @@
 .TE
 
 .SH SEE ALSO
-.LP
 .BR rtld_db (3EXT),
 .BR libc_db (3LIB),
 .BR librtld_db (3LIB),
--- old/usr/src/man/man3proc/ps_lgetregs.3proc	Wed Apr 12 20:33:26 2023
+++ new/usr/src/man/man3proc/ps_lgetregs.3proc	Wed Apr 12 20:33:26 2023
@@ -3,7 +3,8 @@
 .\" The contents of this file are subject to the terms of the Common Development and Distribution License (the "License").  You may not use this file except in compliance with the License.
 .\" You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE or http://www.opensolaris.org/os/licensing.  See the License for the specific language governing permissions and limitations under the License.
 .\" When distributing Covered Code, include this CDDL HEADER in each file and include the License file at usr/src/OPENSOLARIS.LICENSE.  If applicable, add the following below this CDDL HEADER, with the fields enclosed by brackets "[]" replaced with your own identifying information: Portions Copyright [yyyy] [name of copyright owner]
-.TH PS_LGETREGS 3PROC "September 12, 2020"
+.\" Copyright 2023 Oxide Computer Company
+.TH PS_LGETREGS 3PROC "January 23, 2023"
 .SH NAME
 ps_lgetregs, ps_lsetregs, ps_lgetfpregs, ps_lsetfpregs, ps_lgetxregsize,
 ps_lgetxregs, ps_lsetxregs \- routines that access the target process register
@@ -60,13 +61,18 @@
 \fBps_lgetregs()\fR gets the general registers of the \fBLWP\fR identified by
 \fIlid\fR, and \fBps_lsetregs()\fR sets them. \fBps_lgetfpregs()\fR gets the
 \fBLWP\fR's floating point register set, while \fBps_lsetfpregs()\fR sets it.
-.SS "SPARC Only"
-\fBps_lgetxregsize()\fR, \fBps_lgetxregs()\fR, and \fBps_lsetxregs()\fR are
-SPARC-specific. They do not need to be defined by a controlling process on
-non-SPARC architecture. \fBps_lgetxregsize()\fR returns in
-\fB*\fR\fIxregsize\fR the size of the architecture-dependent extra state
-registers. \fBps_lgetxregs()\fR gets the extra state registers, and
-\fBps_lsetxregs()\fR sets them.
+.LP
+\fBps_lgetxregsize()\fR, \fBps_lgetxregs()\fR, and \fBps_lsetxregs()\fR are used
+to get and set the extended register set. Support for an extended register set
+depends on the instruction-set archicture. On platforms without support for
+these, controlling processes wlil still need to define them; however, they are
+allowed to simply return errors.
+.LP
+\fBps_lgetxregsize()\fR returns in \fB*\fR\fIxregsize\fR the size of the
+architecture-dependent extra state registers. \fBps_lgetxregs()\fR gets the
+extra state registers, and \fBps_lsetxregs()\fR sets them. When getting the
+registers, the size of \fIxregset\fR must be at least the size returned by
+\fBps_lgetxregsize()\fR.
 .SH RETURN VALUES
 .ne 2
 .na
@@ -79,7 +85,7 @@
 .sp
 .ne 2
 .na
-\fB\fBPS_NOFPREGS\fR \fR
+\fB\fBPS_NOFREGS\fR \fR
 .ad
 .RS 16n
 Floating point registers are neither available for this architecture nor for
--- old/usr/src/pkg/manifests/system-header.p5m	Wed Apr 12 20:33:27 2023
+++ new/usr/src/pkg/manifests/system-header.p5m	Wed Apr 12 20:33:27 2023
@@ -29,7 +29,7 @@
 # Copyright 2020 Joyent, Inc.
 # Copyright 2019 Peter Tribble.
 # Copyright 2021 OmniOS Community Edition (OmniOSce) Association.
-# Copyright 2022 Oxide Computer company
+# Copyright 2023 Oxide Computer company
 #
 
 set name=pkg.fmri value=pkg:/system/header@$(PKGVERS)
@@ -1353,6 +1353,7 @@
 file path=usr/include/sys/stat_impl.h
 file path=usr/include/sys/statfs.h
 file path=usr/include/sys/statvfs.h
+file path=usr/include/sys/stdalign.h
 file path=usr/include/sys/stdbool.h
 file path=usr/include/sys/stddef.h
 file path=usr/include/sys/stdint.h
--- old/usr/src/pkg/manifests/system-kernel.man2.inc	Wed Apr 12 20:33:27 2023
+++ new/usr/src/pkg/manifests/system-kernel.man2.inc	Wed Apr 12 20:33:27 2023
@@ -88,6 +88,7 @@
 link path=usr/share/man/man2/getaudit_addr.2 target=getaudit.2
 file path=usr/share/man/man2/getauid.2
 file path=usr/share/man/man2/getcontext.2
+link path=usr/share/man/man2/getcontext_extd.2 target=getcontext.2
 file path=usr/share/man/man2/getdents.2
 link path=usr/share/man/man2/getegid.2 target=getuid.2
 link path=usr/share/man/man2/geteuid.2 target=getuid.2
--- old/usr/src/pkg/manifests/system-library.man3c.inc	Wed Apr 12 20:33:27 2023
+++ new/usr/src/pkg/manifests/system-library.man3c.inc	Wed Apr 12 20:33:27 2023
@@ -1264,6 +1264,7 @@
 link path=usr/share/man/man3c/strxfrm_l.3c target=strxfrm.3c
 file path=usr/share/man/man3c/swab.3c
 link path=usr/share/man/man3c/swapcontext.3c target=makecontext.3c
+link path=usr/share/man/man3c/swapcontext_extd.3c target=makecontext.3c
 link path=usr/share/man/man3c/swprintf.3c target=fwprintf.3c
 link path=usr/share/man/man3c/swscanf.3c target=fwscanf.3c
 file path=usr/share/man/man3c/sync_instruction_memory.3c
@@ -1361,6 +1362,8 @@
 file path=usr/share/man/man3c/u8_textprep_str.3c
 file path=usr/share/man/man3c/u8_validate.3c
 file path=usr/share/man/man3c/ualarm.3c
+file path=usr/share/man/man3c/ucontext_alloc.3c
+link path=usr/share/man/man3c/ucontext_free.3c target=ucontext_alloc.3c
 file path=usr/share/man/man3c/uconv_u16tou32.3c
 link path=usr/share/man/man3c/uconv_u16tou8.3c target=uconv_u16tou32.3c
 link path=usr/share/man/man3c/uconv_u32tou16.3c target=uconv_u16tou32.3c
--- old/usr/src/pkg/manifests/system-library.man3proc.inc	Wed Apr 12 20:33:27 2023
+++ new/usr/src/pkg/manifests/system-library.man3proc.inc	Wed Apr 12 20:33:27 2023
@@ -22,6 +22,9 @@
 link path=usr/share/man/man3proc/Ldstop.3proc target=Pstopstatus.3proc
 file path=usr/share/man/man3proc/Lfree.3proc
 link path=usr/share/man/man3proc/Lgetareg.3proc target=Pgetareg.3proc
+link path=usr/share/man/man3proc/Lgetfpregs.3proc target=Plwp_getregs.3proc
+link path=usr/share/man/man3proc/Lgetregs.3proc target=Plwp_getregs.3proc
+link path=usr/share/man/man3proc/Lgetxregs.3proc target=Plwp_getxregs.3proc
 file path=usr/share/man/man3proc/Lgrab.3proc
 file path=usr/share/man/man3proc/Lgrab_error.3proc
 link path=usr/share/man/man3proc/Lmain_stack.3proc target=Plwp_stack.3proc
@@ -28,7 +31,10 @@
 file path=usr/share/man/man3proc/Lprochandle.3proc
 file path=usr/share/man/man3proc/Lpsinfo.3proc
 link path=usr/share/man/man3proc/Lputareg.3proc target=Pgetareg.3proc
+link path=usr/share/man/man3proc/Lsetfpregs.3proc target=Plwp_getregs.3proc
+link path=usr/share/man/man3proc/Lsetregs.3proc target=Plwp_getregs.3proc
 link path=usr/share/man/man3proc/Lsetrun.3proc target=Psetrun.3proc
+link path=usr/share/man/man3proc/Lsetxregs.3proc target=Plwp_getxregs.3proc
 link path=usr/share/man/man3proc/Lstack.3proc target=Plwp_stack.3proc
 file path=usr/share/man/man3proc/Lstate.3proc
 file path=usr/share/man/man3proc/Lstatus.3proc
@@ -86,6 +92,7 @@
 link path=usr/share/man/man3proc/Plookup_by_name.3proc \
     target=Plookup_by_addr.3proc
 link path=usr/share/man/man3proc/Plwp_alt_stack.3proc target=Plwp_stack.3proc
+link path=usr/share/man/man3proc/Plwp_freexregs.3proc target=Plwp_getxregs.3proc
 file path=usr/share/man/man3proc/Plwp_getasrs.3proc
 link path=usr/share/man/man3proc/Plwp_getfpregs.3proc target=Plwp_getregs.3proc
 file path=usr/share/man/man3proc/Plwp_getgwindows.3proc
